// See page.html for test modes.
//
// Merely calling storage.sync leaks jsonSandbox (when the page is unloaded). Call stack:
// https://searchfox.org/mozilla-central/rev/c0d81882c7941c4ff13a50603e37095cdab0d1ea/toolkit/components/extensions/ExtensionCommon.jsm#259-268
// https://searchfox.org/mozilla-central/rev/53afcfdbabed96883126d0ebbcac499b358e32f2/toolkit/components/extensions/child/ext-storage.js#66-81
// https://searchfox.org/mozilla-central/rev/53afcfdbabed96883126d0ebbcac499b358e32f2/toolkit/components/extensions/child/ext-storage.js#119-121
// (^^ that is tested if testMode=1 or testMode=2)
//
// If the result of storage.sync.get is accessed, then the content script sandbox is leaked too.
// (^^ that is tested if testMode=2)
//
if (location.search.includes('testMode=1') || location.search.includes('testMode=2')) {
    chrome.storage.sync.get({
        booleanValue: true,
    }, function(items) {
        // If the result is ignored, then only the JSON sandbox is leaked
        // (" [anonymous sandbox] (from: resource://gre/modules/ExtensionCommon.jsm:331)")
        if (location.search.includes('testMode=2')) {
            // IF the add-on has a temporary Add-on ID (i.e. applications.gecko.id is missing):
            // When a property of items is accessed, then the content script sandbox is leaked too.
            void items.booleanValue;
        }
    });
}
